VERSION 5.00
Begin VB.Form frmEncrypt 
   Caption         =   "Simple Encryptor"
   ClientHeight    =   4215
   ClientLeft      =   420
   ClientTop       =   855
   ClientWidth     =   9720
   Icon            =   "SimpEncrypt.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4215
   ScaleWidth      =   9720
   Begin VB.CheckBox chkHidePassword 
      Caption         =   "Hide Password"
      Height          =   255
      Left            =   4133
      TabIndex        =   11
      Top             =   600
      Value           =   1  'Checked
      Width           =   1455
   End
   Begin VB.CommandButton cmdClipToPlain 
      Caption         =   "<--"
      Height          =   495
      Left            =   3600
      TabIndex        =   9
      ToolTipText     =   "Copy Clipboard Contents to Ciphertext Window."
      Top             =   3240
      Width           =   735
   End
   Begin VB.CommandButton cmdClipToCipher 
      Caption         =   "-->"
      Height          =   495
      Left            =   5400
      TabIndex        =   7
      ToolTipText     =   "Copy Clipboard Contents to Ciphertext Window."
      Top             =   3240
      Width           =   735
   End
   Begin VB.CommandButton cmdDecipher 
      BackColor       =   &H00C0FFC0&
      Caption         =   "<< &Decipher"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4193
      Style           =   1  'Graphical
      TabIndex        =   3
      Top             =   2400
      Width           =   1335
   End
   Begin VB.CommandButton cmdEncipher 
      BackColor       =   &H00C0C0FF&
      Caption         =   "&Encipher >>"
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   4193
      Style           =   1  'Graphical
      TabIndex        =   2
      ToolTipText     =   "Copies Enciphered Text to Clipboard."
      Top             =   1800
      Width           =   1335
   End
   Begin VB.TextBox txtPassword 
      Height          =   285
      IMEMode         =   3  'DISABLE
      Left            =   3833
      TabIndex        =   1
      ToolTipText     =   "Case Sensitive, Blanks Ok."
      Top             =   960
      Width           =   2055
   End
   Begin VB.TextBox txtCipher 
      Height          =   3615
      Left            =   6240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      ToolTipText     =   "Double-Click to Clear Window."
      Top             =   120
      Width           =   3375
   End
   Begin VB.TextBox txtPlain 
      Height          =   3615
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      ToolTipText     =   "Double-Click to Clear Window."
      Top             =   120
      Width           =   3375
   End
   Begin VB.Frame Frame1 
      Caption         =   "Password"
      Height          =   1335
      Left            =   3720
      TabIndex        =   12
      Top             =   240
      Width           =   2295
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Clipboard"
      Height          =   255
      Left            =   4440
      TabIndex        =   10
      Top             =   3360
      Width           =   855
   End
   Begin VB.Label lblNruns 
      Alignment       =   2  'Center
      Height          =   255
      Left            =   4620
      TabIndex        =   8
      ToolTipText     =   "Number of Times Program Has Been Used."
      Top             =   3840
      Width           =   495
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Ciphertext"
      Height          =   255
      Index           =   1
      Left            =   7080
      TabIndex        =   6
      Top             =   3840
      Width           =   1695
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Plaintext"
      Height          =   255
      Index           =   0
      Left            =   960
      TabIndex        =   5
      Top             =   3840
      Width           =   1695
   End
End
Attribute VB_Name = "frmEncrypt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'The original version of this program was written by Rod Stephens, Boulder,
'Colorado of VB-Helper fame. The program's original name was Cipher.
'
'Charlie Rose, Boulder, Colorado merely wrapped some pretty stuff around
'the core program to change it from an example to a production unit. He
'changed the name to SimpEncrypt so as not to collide with the name Cipher.
'
'Some of the modifications that were made are:
'   1. Added a run number that is incremented whenever an encryption or
'      decryption is performed.
'   2. Enabled the password to be hidden.
'   3. Registry used to remember form's position, password-hiding state,
'      and run number.
'   4. Enabled the password to be erased by bonking the Esc key.
'   5. Added controls to copy the clipboard into either the PlainText or
'      CipherText windows. This was done for mouse-lovers.
'   6. Added ability to erase the password, plaintext, and ciphertext
'      windows by double-clicking them.
'   7. Color-coded the Encrypt/Decrypt command buttons.
'   8. Copies newly encrypted text to the clipboard automatically.

'Version 1.5.0: 2001.08.29


Option Explicit

'Const AppName As String = "VATEsupport" 'Ignore this. It's for a special application.
Const AppName As String = "SimpEncrypt" 'Specifies Registry Entry Name

Private Const MIN_ASC = 32  ' Space.
Private Const MAX_ASC = 126 ' ~.
Private Const NUM_ASC = MAX_ASC - MIN_ASC + 1

Dim N_Runs As Integer

' Encipher the text using the password.

Private Sub Encipher(ByVal password As String, ByVal from_text As String, to_text As String)
  Dim str_len As Integer
  Dim i As Integer
  Dim ch As Integer

  ' Initialize the random number generator.
    
  Rnd -1
  Randomize NumericPassword(password)

  ' Encipher the string.
    
  str_len = Len(from_text)
  
  For i = 1 To str_len
    ch = Asc(Mid$(from_text, i, 1))

    ' Ignore non-printing characters.
        
    If (ch >= MIN_ASC And ch <= MAX_ASC) Then
      ch = ch + Int(NUM_ASC * Rnd)
        If ch > MAX_ASC Then
          ch = ch - NUM_ASC
        End If
      to_text = to_text & Chr$(ch)
    End If
  Next i
    
  Clipboard.Clear
  Clipboard.SetText (to_text)
End Sub

' Decipher the text using the password.

Private Sub Decipher(ByVal password As String, ByVal from_text As String, to_text As String)
  Dim str_len As Integer
  Dim i As Integer
  Dim ch As Integer

  ' Initialize the random number generator.
    
  Rnd -1
  Randomize NumericPassword(password)

  ' Decipher the string.
    
  str_len = Len(from_text)
  For i = 1 To str_len
    ch = Asc(Mid$(from_text, i, 1))
        
    ' Ignore non-printing characters.
        
    If ch >= MIN_ASC And ch <= MAX_ASC Then
      ch = ch - Int(NUM_ASC * Rnd)
        If ch < MIN_ASC Then
          ch = ch + NUM_ASC
        End If
      to_text = to_text & Chr$(ch)
    End If
  Next i
End Sub

' Translate a password into an offset value.

Private Function NumericPassword(ByVal password As String) As Long
  Dim value As Long
  Dim ch As Long
  Dim shift1 As Long
  Dim shift2 As Long
  Dim i As Integer
  Dim str_len As Integer

  shift1 = 3
  shift2 = 17
  value = 0
  
  str_len = Len(password)
  
  For i = 1 To str_len
    ' Add the next letter.
        
    ch = Asc(Mid$(password, i, 1))
    value = value Xor (ch * 2 ^ shift1)
    value = value Xor (ch * 2 ^ shift2)

    ' Change the shift offsets.
        
    shift1 = (shift1 + 7) Mod 19
    shift2 = (shift2 + 13) Mod 23
  Next i
  
  NumericPassword = value
End Function

'Control whether password is hidden or shown

Private Sub chkHidePassword_Click()
  If (chkHidePassword.value = vbChecked) Then
    txtPassword.PasswordChar = "*"
  Else
    txtPassword.PasswordChar = ""
  End If
  
  Call SaveSetting(AppName, "General", "HidePassword", chkHidePassword.value)
End Sub

Private Sub cmdEncipher_Click()
  Dim cipher_text As String

  Call Encipher(txtPassword.Text, txtPlain.Text, cipher_text)
  txtCipher.Text = cipher_text
  Call BumpRunCounter
End Sub

Private Sub cmdDecipher_Click()
  Dim plain_text As String
  
  Call Decipher(txtPassword.Text, txtCipher.Text, plain_text)
  txtPlain.Text = plain_text
  Call BumpRunCounter
End Sub

'Copy Clipboard to the Cipher Text Window

Private Sub cmdClipToCipher_Click()
  txtCipher.Text = Clipboard.GetText()
End Sub

'Copy Clipboard to the Plain Text Window

Private Sub cmdClipToPlain_Click()
  txtPlain.Text = Clipboard.GetText()
End Sub

' Enable the appropriate buttons.

Private Sub txtPassword_Change()
  If Len(txtPassword.Text) > 0 Then
    cmdEncipher.Enabled = True
    cmdDecipher.Enabled = True
  Else
    cmdEncipher.Enabled = False
    cmdDecipher.Enabled = False
  End If
End Sub

'Form Load Handler

Private Sub Form_Load()
  frmEncrypt.Caption = "Simple Encryptor: Ver. " & App.Major & "." & App.Minor & "." & App.Revision
  
  Me.Left = GetSetting(AppName, "General", "Left_Pos", 0)
  Me.Top = GetSetting(AppName, "General", "Top_Pos", 0)
  N_Runs = GetSetting(AppName, "General", "N_Runs", 0)
  chkHidePassword.value = GetSetting(AppName, "General", "HidePassword", 1)
  
  lblNruns.Caption = Str(N_Runs)
  
  txtPassword.PasswordChar = "*"
End Sub

'Form Unload Handler

Private Sub Form_Unload(Cancel As Integer)
  If (Me.WindowState <> vbMinimized) Then
    SaveSetting AppName, "General", "Left_Pos", Me.Left
    SaveSetting AppName, "General", "Top_Pos", Me.Top
  End If
End Sub

'Erase the PlainText Window

Private Sub txtPlain_DblClick()
  txtPlain = ""
End Sub

'Erase the CipherText Window

Private Sub txtCipher_DblClick()
  txtCipher.Text = ""
End Sub

'Maintain and Display the Run Counter. N_Runs in incremented whenever
'an encryption or decryption is performed.

Public Sub BumpRunCounter()
  N_Runs = N_Runs + 1
  SaveSetting AppName, "General", "N_Runs", N_Runs
  lblNruns.Caption = Str(N_Runs)
End Sub

'Erase the Password Quickly in case a Spy comes into the room.
'There are KeyPress event handlers for every control on the
'form, all of which call txtPassword_DblClick(). This is a very
'cumbersome way to make sure the user can erase the password by
'bonking the Esc key regardless of which control has focus ...
'I just don't know a better way to do it. Grump!

Private Sub txtPassword_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub txtPlain_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub txtCipher_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub cmdEncipher_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub cmdDecipher_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub chkHidePassword_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub cmdClipToCipher_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub cmdClipToPlain_KeyPress(KeyAscii As Integer)
  TestEscKey (KeyAscii)
End Sub

Private Sub TestEscKey(Key As Integer)
  If (Key = 27) Then
    Call txtPassword_DblClick
  End If
End Sub

Private Sub txtPassword_DblClick()
  txtPassword.Text = ""
End Sub

